;;; advent.lsp.  Load this file to load the adventure:
;;; then type (advent)
;;;
;;;
;;; ...in which a little lisp is shown to go a long way.
;;;
;;; This small (but complete) implementation of the colossal
;;; cave adventure is intended to demonstrate how to use some
;;; of the nice features of LISP, and of Common LISP in particular.
;;; There are many routines and ideas in here that could be used
;;; for other purposes.
;;;
;;; The cave is represented as an array of rooms.  Each
;;; room is a structure instance.  Things in each room
;;; are kept on the property list of the 'things' field
;;; in each room.  The command parser converts raw typed-in
;;; lines into a list of words which is easily manipulated
;;; via standard list commands.
;;;
;;; This is mostly a data driven implementation (as is proper).
;;; You may want to max out your buffers for a more enjoyable
;;; game.   Consult the manual entry for -v and -p for the
;;; exact incantation.   Advent tends to thrash with the default
;;; buffer size settings due to a large number of complicated
;;; data structures.
;;; 
;;; Think of this as the Cliff Notes version of Adventure.

;;; Author -- John Bruno Hare.   Shanghai, 1988.
;;; (c) Copyright 1988 John Bruno Hare, all rights reserved.
(load "astruct.lsp" :verbose t)
(load "ainit.lsp" :verbose t)
(load "autil.lsp" :verbose t)
(load "amove.lsp" :verbose t)
(load "aobject.lsp" :verbose t)
(load "avocab.lsp" :verbose t)
(load "aroom.lsp" :verbose t)
(load "abadguy.lsp" :verbose t)
(load "aendgame.lsp" :verbose t)
(load "aplay.lsp" :verbose t)
