; aendgame.lsp			 :ts=2
;;; Author -- John Bruno Hare.   Shanghai, 1988.
;;; (c) Copyright 1988 John Bruno Hare, all rights reserved.

(defun end-game-init()
		(setq
			*end-game-room-list*
			'(
				(make-room
					:short-desc "warehouse"
					:long-desc
"This is a large room, the warehouse for the adventure game.
There are piles of iron rods.  In one corner is a huge
box of wicker birdcages packed in plastic peanuts.
Dozens of sleeping dwarves snore in every nook and cranny."
					:paths '(north 1))

				(make-room
					:short-desc "main office anteroom"
					:long-desc
"This is a waiting room just off the main office.  There is a
locked door into the office.   There are uncomfortable
chairs here in mismatched colors."
					:paths '(south 0)
					:things (make-inventory '(magazine)))
			)		;;; end of *end-game-room-list*
		)
		(setq *end-game-rooms*  (make-array 2))
		(setf (aref *end-game-rooms* 0) (eval (first *end-game-room-list*)))
		(setf (aref *end-game-rooms* 1) (eval (second *end-game-room-list*)))
)

(defun end-game(x y)
	(end-game-init)
	(format t
"~!A scratchy voice comes over a loudspeaker which is next to
a birds' nest in the corner of the well house:

THE CAVE IS NOW CLOSED.  ALL ADVENTURERS PLEASE REPORT TO
THE MAIN OFFICE.~%")

	(format t "[press any key to continue]~%")
	(readkey)
	(cls)
	(format t "You dissapear in a puff of orange smoke~%")
	(let ((end-game-room-num 0))
		(loop
			(let ((room (aref *end-game-rooms* end-game-room-num)))
				(if (not (room-visited-p room))
					(format t "~a~%" (room-long-desc room))
					(format t "~a~%" (room-short-desc room)))
				(if (get (room-things room) 'magazine)
					(format t
"The only reading material is a dogeared copy of Modern Spelunker magazine.~%"))
			(format t "> ")	; output prompt
			(let ((cmd-list (getcmd)))
				(if (and (not cmd-list)
							(y-or-n-p
								"This part is easy...do you really want to quit now? "))
						(throw 'top-level-advent  'nil))
				(let ((verb (get-true-name (first cmd-list)))
							(object (get-true-name (second cmd-list)))
							(is-motion-verb))
								(cond
									; is this a directional "verb"?
									((or (gethash verb *dir-verbs-ht*)
												(setq is-motion-verb (eq verb 'go)))
										(if is-motion-verb
											; use second word instead
											(setq verb object))
										(if (magic-motion-verb-p verb)
												(format t "nothing happens...~%")
											; hardwired motion algorithm
											(if (and (eq end-game-room-num 0)(eq verb 'north))
												(setq end-game-room-num 1)
													(if (and (eq end-game-room-num 1)(eq verb 'south))
														(setq end-game-room-num 0)
															(format t "you can't get out that way.~%")))))

									((or (eq verb 'look)(eq verb 'describe)(eq verb 'read))
										(if (null object)
											(format t "~a~%" (room-long-desc room))
											(if (and 
														(eq object 'magazine)(get *adventurer* 'magazine))
													(read-magazine)
												(format t "my lips are sealed~%"))))

									((eq verb 'drop)
										(if (not (eq object 'magazine))
												(format t "you don't have that~%"))
										 (if (and (= end-game-room-num 0)
										 				(get *adventurer* 'magazine))
										 		(progn
													(total-winner)
													(throw 'top-level-advent t))
												(progn
												(remprop *adventurer* 'magazine)
												(setf (get (room-things room) 'magazine) t)
												(format t
														"thwack.  You drop the magazine in boredom...~%"))))

									((and (eq verb 'get)(eq object 'magazine))
										(remprop (room-things room) 'magazine)
										(setf (get *adventurer* 'magazine) t)
										(format t "Picked up the magazine.~%"))

									((eq verb 'inventory)
										(if (get *adventurer* 'magazine)
											(format t
												"You have a dogeared copy of Modern Spelunker.~%")
										(format t "you are not carrying anything~%")))

									((and (eq end-game-room-num 0)
										(or (eq object 'dwarf)(eq object 'dwarves)))
												(format t
"A sign appears in mid-air:

DO NOT DISTURB THE DWARVES~%"))

									(t
										(case (dice 6)
											(0 (format t "Now that won't accomplish anything.~%"))
											(1 (if (y-or-n-p "give up? ")
												(throw 'top-level-advent  'nil)))
											(2 (format t "don't be silly!~%"))
											(3 (format t "That won't get us out of here.~%"))
											(4 (format t "Yow! are we having fun yet?~%"))
											(5 (format t "don't panic!~%"))))))
				(if (not (room-visited-p room))
						(setf (room-visited-p room) t)))))))

(defun read-magazine()
	(format t
"The only article of interest is 'The Frobber 1200 repeating
magic axe: bug or feature?'~%"))

(defun total-winner()
	(cls)(cls)(cls)
	(format t
"~!~!KABLOOOOOOOOOOOOOOOOOOM!  The warehouse wall blows into a million
bits.  When the smoke clears, a jubulant crowd of elves carry you
off on their shoulders into the sunset.~%~%")
	(format t
"You are a total winner, a grandmaster adventurer~%")
 (credits))

(defun credits()
	(format t
"                   CREDITS

Star Sapphire Common LISP Adventure implementation by John Bruno Hare
based on the original SAIL game by Crowther and Woods~%")
	(format t
"Star Sapphire Common LISP is a trademark of Sapiens Software Corporation.~%")
	(format t
"The Froon Mercury News, Frobber 1200, the zorkmid and the
rusty lantern are service marks of Frobozzco Resorts International.~%")
	(format t "Dwarf #1.........Marlon Bananna~%")
	(format t "Dwarf #2.........Dannie FehVito~%")
	(format t "Dwarf #3.........Mickey Frooney~%")
	(format t "The Pirate.......special appearance by Roger Rabbit~%")

	(format t "Property list manager.....John Remprop~%")
	(format t "Special variable effects by Industrial Hacks and Magic~%")
	(format t "Lexical scoping appears courtesy of Guy L. Feebor Jr.~%")
	(format t "Theme song 'Where the rooms have no name' sung by Y2~%")
	(format t
"Filmed on location in the Caltech steam tunnels, Shanghai and Santa Cruz~%"))
