;;; amove.lsp -- motion code for advent program  :ts=2
;;; Author -- John Bruno Hare.   Shanghai, 1988.
;;; (c) Copyright 1988 John Bruno Hare, all rights reserved.

; adventurer goes from-room to-room
; centralizing this allows us to special case certain moves
; return the room moved to
; note that this does not reset *cur-room-num*: the return
; from this should immediately be setq-ed thence.
(defun move-adventurer(from-room to-room)
	(cond

		((and (eq from-room *above-the-grate*)
			(eq to-room *below-the-grate*))
				(if *grate-locked*
					(progn
						(format t "the grate is locked~%")
						from-room)
				*below-the-grate*))

		((and (eq from-room *on-the-ledge*)
				(eq to-room *top-of-stairs*)
				(get *adventurer* 'gold))
				(progn
					(format t
					"whoops...  you seem to have gotten turned around on the stairs~%")
					*on-the-ledge*))

		((and (eq from-room *hall-of-mtn-king*)
					(not (eq to-room *on-the-ledge*))
					(get (room-things (aref *rooms* *hall-of-mtn-king*)) 'snake))
				(progn
					(format t "The snake slithers into your path and bars your way~%")
					*hall-of-mtn-king*))

		((and (not *killed-dragon*)
					(eq from-room *dragon-room*)
					(not (eq to-room *hall-of-mtn-king*)))
				(progn
					(format t "The dragon is in your way.~%")
					*dragon-room*))

		((and (eq to-room *sapphire-room*)
				(or (eq from-room *dragon-room*)(eq from-room *y2*))
				(get *adventurer* 'lantern))
						(progn
							(format t
"something you are carrying is preventing you from entering the
flickering curtain of light~%")
								from-room))

		((eq to-room *treasure-room*)
			(setq *found-treasure* t)
			*treasure-room*)

		(t to-room)))

; if you really want to ....
(defun try-jump(room)
	(if (not (member *cur-room-num* *crevasse-rooms*))
			(format t "you hop up and down... you look pretty silly.~%")
		(if (y-or-n-p "are you sure? ")
			(progn
				(format t "ah")
				(do ((i 0 (1+ i)))
						((= i 500)
							(progn 
								(format t "~%....thump")
									(error "~%you are squashed flat")))
					(princ '\h)))
					t)))
