;;; autil.lsp -- random useful functions for advent program :ts=2
;;; Author -- John Bruno Hare.   Shanghai, 1988.
;;; (c) Copyright 1988 John Bruno Hare, all rights reserved.

; If the list is nil, construct a list with thing as its only element.
; If the list is not nil, append thing at its tail.
; Will lose if list is NOT a symbol with a cons value:
; this is not really very general.
; The point of this is to avoid the hassle of consing up a list
; using push and then having to reverse it.
(defmacro revpush(thing list)
	`(if (null ,list)
		(setq ,list (list ,thing))
	(setf (cdr (last ,list))(cons ,thing nil))))
