;;; :ts=2
;;; INIT.LSP - LISP initialization file.
;;; This file is loaded by default each time lisp.exe is booted.
;;; IMPORTANT: Optional initializations can be found in init0.lsp, and can be
;;; added as needed to this file for execution at startup (or
;;; to specific program files).  This includes most setf methods.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; (c) Copyright 1988-92 Sapiens Software Corporation, All Rights Reserved.
;;; This source code is considered a proprietary trade secret of
;;; Sapiens Software Corporation, and is provided under license
;;; to purchasers of Star Sapphire Common LISP for use only per terms
;;; of their license agreement.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; boot sequence starts here.
; these files are both optional and only needed if you want to use the
; given feature.  You can comment these out or comment out the y-or-n-p
; if you want.
(if (y-or-n-p "full system? ")
	(progn
		(load 'defsetf.fsl :verbose t)	; initialize setf
		(load 'defstruc.fsl :verbose t)	; initialize defstruct (note: needs defsetf)
		(load 'clos.fsl :verbose t)			; initialize clos macros
		(load 'time.fsl :verbose t)			; initialize time macro
		(load 'wofile.fsl :verbose t)	; initialize with-open-file
))
;;;;;;;;;;;;;;;;; boot code ends here ;;;;;;;;;;;;;;;
;;;; you can put anything you want after this point. e.g.,
; colors for IBM PC screen output
(setq black 0 blue 1 green 2 cyan 3 red 4 magenta 5 brown 6 white 7
	dark-gray 8 light-blue 9 light-green 10 light-cyan 11
	light-red 12 light-magenta 13 yellow 14 bright-white 15)
; names for some extended codes
(setq F1 #x3b F2 #x3c F5 #x3f F10 #x44 ALT-E #x12 ALT-R #x13 ALT-Z #x2c)
; some useful key assignments -- feel free to alter these and add
; any others that you want.
(set-keyboard-expansion F1 '(help))
(set-keyboard-expansion F2 '(ed))
(set-keyboard-expansion F5 '(popdir))
(set-keyboard-expansion F10 '(run))
(set-keyboard-expansion ALT-E "(ed '" :alt t)
(set-keyboard-expansion ALT-R "(run '" :alt t)
(set-keyboard-expansion ALT-Z '(bye) :alt t)
;;; end of initialization sequence
;;; more initialization in init0.lsp (can be added here)
