
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; code in this module is all optional, you can add it to init.lsp if you want
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defsetf aref aset)
(defsetf get (s p &optional d) (v) `(putprop ,s ,v ,p))
(defsetf car (x) (y) `(progn (rplaca ,x ,y) ,y))
(defsetf cdr (x) (y) `(progn (rplacd ,x ,y), y))
(defsetf caar (x) (y) `(progn (rplaca (car ,x) ,y) ,y))
(defsetf cdar (x) (y) `(progn (rplacd (car ,x) ,y) ,y))
(defsetf cadr (x) (y) `(progn (rplaca (cdr ,x) ,y) ,y))
(defsetf cddr (x) (y) `(progn (rplacd (cdr ,x) ,y) ,y))
(defsetf caaar (x) (y) `(progn (rplaca (caar ,x) ,y) ,y))
(defsetf cdaar (x) (y) `(progn (rplacd (caar ,x) ,y) ,y))
(defsetf cadar (x) (y) `(progn (rplaca (cdar ,x) ,y) ,y))
(defsetf cddar (x) (y) `(progn (rplacd (cdar ,x) ,y) ,y))
(defsetf caadr (x) (y) `(progn (rplaca (cadr ,x) ,y) ,y))
(defsetf cdadr (x) (y) `(progn (rplacd (cadr ,x) ,y) ,y))
(defsetf caddr (x) (y) `(progn (rplaca (cddr ,x) ,y) ,y))
(defsetf cdddr (x) (y) `(progn (rplacd (cddr ,x) ,y) ,y))
(defsetf caaaar (x) (y) `(progn (rplaca (caaar ,x) ,y) ,y))
(defsetf cdaaar (x) (y) `(progn (rplacd (caaar ,x) ,y) ,y))
(defsetf cadaar (x) (y) `(progn (rplaca (cdaar ,x) ,y) ,y))
(defsetf cddaar (x) (y) `(progn (rplacd (cdaar ,x) ,y) ,y))
(defsetf caadar (x) (y) `(progn (rplaca (cadar ,x) ,y) ,y))
(defsetf cdadar (x) (y) `(progn (rplacd (cadar ,x) ,y) ,y))
(defsetf caddar (x) (y) `(progn (rplaca (cddar ,x) ,y) ,y))
(defsetf cdddar (x) (y) `(progn (rplacd (cddar ,x) ,y) ,y))
(defsetf caaadr (x) (y) `(progn (rplaca (caadr ,x) ,y) ,y))
(defsetf cdaadr (x) (y) `(progn (rplacd (caadr ,x) ,y) ,y))
(defsetf cadadr (x) (y) `(progn (rplaca (cdadr ,x) ,y) ,y))
(defsetf cddadr (x) (y) `(progn (rplacd (cdadr ,x) ,y) ,y))
(defsetf caaddr (x) (y) `(progn (rplaca (caddr ,x) ,y) ,y))
(defsetf cdaddr (x) (y) `(progn (rplacd (caddr ,x) ,y) ,y))
(defsetf cadddr (x) (y) `(progn (rplaca (cdddr ,x) ,y) ,y))
(defsetf cddddr (x) (y) `(progn (rplacd (cdddr ,x) ,y) ,y))
(defsetf first (x) (y) `(progn (rplaca ,x ,y) ,y))
(defsetf second (x) (y) `(progn (rplaca (cdr ,x) ,y) ,y))
(defsetf third (x) (y) `(progn (rplaca (cddr ,x) ,y) ,y))
(defsetf fourth (x) (y) `(progn (rplaca (cdddr ,x) ,y) ,y))
(defsetf fifth (x) (y) `(progn (rplaca (cddddr ,x) ,y) ,y))
(defsetf sixth (x) (y) `(progn (rplaca (nthcdr 5 ,x) ,y) ,y))
(defsetf seventh (x) (y) `(progn (rplaca (nthcdr 6 ,x) ,y) ,y))
(defsetf eighth (x) (y) `(progn (rplaca (nthcdr 7 ,x) ,y) ,y))
(defsetf ninth (x) (y) `(progn (rplaca (nthcdr 8 ,x) ,y) ,y))
(defsetf tenth (x) (y) `(progn (rplaca (nthcdr 9 ,x) ,y) ,y))
(defsetf rest (x) (y) `(progn (rplacd ,x ,y) ,y))
(defsetf svref svset)
(defsetf elt set-elt)
(defsetf symbol-value set)
(defsetf symbol-function set-symbol-function)
(defsetf macro-function (s) (v) `(progn (fset ,s (cons 'macro ,v)) ,v))
(defsetf nth (n l) (v) `(progn (rplaca (nthcdr ,n ,l) ,v) ,v))
(defsetf char aset)
(defsetf bit aset)
(defsetf sbit aset)
(defsetf fill-pointer set-fill-pointer)
(defsetf symbol-plist set-symbol-plist)
(defsetf gethash (k h &optional d) (v) `(puthash ,k ,h ,v))
(defsetf documentation (s d) (v) `(set-documentation ,s ,d ,v))
(defmacro remf (place indicator)
  (multiple-value-bind (vars vals stores store-form access-form)
      (get-setf-method place)
    `(let* ,(mapcar #'list vars vals)
       (multiple-value-bind (,(car stores) flag)
           (rem-f ,access-form ,indicator)
         ,store-form
         flag))))
(defmacro define-setf-method (access-fn &rest rest)
  `(progn (putprop ',access-fn 'setf-method #'(lambda ,@rest))
          (remprop ',access-fn 'setf-lambda)
          (remprop ',access-fn 'setf-update-fn)
          (set-documentation ',access-fn 'setf
                      ,(find-documentation (cdr rest)))
          ',access-fn))
(define-setf-method apply (fn &rest rest)
  (unless (and (consp fn)
               (or (eq (car fn) 'function) (eq (car fn) 'quote))
               (symbolp (cadr fn))
               (null (cddr fn)))
    (error "Can't get the setf-method of ~S." fn))
  (multiple-value-bind (vars vals stores store-form access-form)
      (get-setf-method (cons (cadr fn) rest))
    (cond ((eq (car (last store-form)) (car (last vars)))
           (values vars vals stores
                   `(apply #',(car store-form) ,@(cdr store-form))
                   `(apply #',(cadr fn) ,@(cdr access-form))))
          ((eq (car (last (butlast store-form))) (car (last vars)))
           (values vars vals stores
                   `(apply #',(car store-form)
                           ,@(cdr (butlast store-form 2))
                           (append ,(car (last (butlast store-form)))
                                   (list ,(car (last store-form)))))
                   `(apply #',(cadr fn) ,@(cdr access-form))))
          (t (error "Can't get the setf-method of ~S." fn)))))
(defmacro pushnew (item place &rest rest)
  (multiple-value-bind (vars vals stores store-form access-form)
      (get-setf-method place)
    `(let* ,(mapcar #'list
		    (append vars stores)
		    (append vals
			    (list (list* 'adjoin item access-form rest))))
       ,store-form)))
(define-setf-method getf (place indicator &optional default)
  (multiple-value-bind (vars vals stores store-form access-form)
      (get-setf-method place)
    (let ((itemp (gensym)) (store (gensym)))
      (values `(,@vars ,itemp)
              `(,@vals ,indicator)
              (list store)
              `(let ((,(car stores) (put-f ,access-form ,store ,itemp)))
                 ,store-form
                 ,store)
              `(getf ,access-form ,itemp ,default)))))
(defsetf subseq (sequence1 start1 &optional end1)
		(sequence2)
  `(replace ,sequence1 ,sequence2 :start1 ,start1 :end1 ,end1))
(define-setf-method the (type form)
  (multiple-value-bind (vars vals stores store-form access-form)
      (get-setf-method form)
    (let ((store (gensym)))
      (values vars vals (list store)
	      `(let ((,(car stores) (the ,type ,store))) ,store-form)
	      `(the ,type ,access-form)))))
;;; Chapter 5 - PROGRAM STRUCTURE
(defvar lambda-list-keywords 
	'(&optional &rest &key &allow-other-keys &aux &body &whole &environment))
(defconstant lambda-parameters-limit 65536)

;;; Chapter 7 -- CONTROL STRUCTURE
;;; PSETF macro.

(defmacro psetf (&rest rest)
  (cond ((endp rest) nil)
        ((endp (cdr rest)) (error "~S is an illegal PSETF form." rest))
        ((endp (cddr rest))
         `(progn ,(setf-expand-1 (car rest) (cadr rest))
                 nil))
        (t
	 (do ((r rest (cddr r))
	      (pairs nil)
	      (store-forms nil))
	     ((endp r)
	      `(let* ,pairs
		 ,@(nreverse store-forms)
		 nil))
	   (when (endp (cdr r)) (error "~S is an illegal PSETF form." rest))
	   (multiple-value-bind (vars vals stores store-form access-form)
	       (get-setf-method (car r))
             (declare (ignore access-form))
	     (setq store-forms (cons store-form store-forms))
	     (setq pairs
		   (nconc pairs
			  (mapcar #'list
				  (append vars stores)
				  (append vals (list (cadr r)))))))))))

;;; SHIFTF macro.
(defmacro shiftf (&rest rest)
  (do ((r rest (cdr r))
       (pairs nil)
       (stores nil)
       (store-forms nil)
       (g (gensym))
       (access-forms nil))
      ((endp (cdr r))
       (setq stores (nreverse stores))
       (setq store-forms (nreverse store-forms))
       (setq access-forms (nreverse access-forms))
       `(let* ,(nconc pairs
		      (list (list g (car access-forms)))
		      (mapcar #'list stores (cdr access-forms))
		      (list (list (car (last stores)) (car r))))
	    ,@store-forms
	    ,g))
    (multiple-value-bind (vars vals stores1 store-form access-form)
	(get-setf-method (car r))
      (setq pairs (nconc pairs (mapcar #'list vars vals)))
      (setq stores (cons (car stores1) stores))
      (setq store-forms (cons store-form store-forms))
      (setq access-forms (cons access-form access-forms)))))

;;; ROTATEF macro.
(defmacro rotatef (&rest rest)
  (do ((r rest (cdr r))
       (pairs nil)
       (stores nil)
       (store-forms nil)
       (access-forms nil))
      ((endp r)
       (setq stores (nreverse stores))
       (setq store-forms (nreverse store-forms))
       (setq access-forms (nreverse access-forms))
       `(let* ,(nconc pairs
		      (mapcar #'list stores (cdr access-forms))
		      (list (list (car (last stores)) (car access-forms))))
	    ,@store-forms))
    (multiple-value-bind (vars vals stores1 store-form access-form)
	(get-setf-method (car r))
      (setq pairs (nconc pairs (mapcar #'list vars vals)))
      (setq stores (cons (car stores1) stores))
      (setq store-forms (cons store-form store-forms))
      (setq access-forms (cons access-form access-forms)))))

(defconstant call-arguments-limit 32768)
(defconstant multiple-values-limit 32768)

;;; Chapter 12 -- NUMBERS
; these are designed to work properly with boole
(defconstant boole-clr 0)
(defconstant boole-set #xF)
(defconstant boole-1  3)
(defconstant boole-2  5)
(defconstant boole-c1 #xC)
(defconstant boole-c2 #xA)
(defconstant boole-and 1)
(defconstant boole-ior 7)
(defconstant boole-xor 6)
(defconstant boole-eqv 9)
(defconstant boole-nand #xE)
(defconstant boole-nor 8)
(defconstant boole-andc1 4)
(defconstant boole-andc2 2)
(defconstant boole-orc1 #xD
(defconstant boole-orc2 #xB)
; the signum macro
(defmacro signum (x)
	`(if (zerop ,x) ,x (/ ,x (abs ,x))))
(defconstant most-positive-fixnum 32766)
(defconstant most-negative-fixnum -32766)
(defconstant most-positive-short-float 1.7e308)
(defconstant least-positive-short-float 1.7e-308)
(defconstant most-negative-short-float -1.7e308)
(defconstant least-negative-short-float -1.7e-308)
(defconstant most-positive-single-float 1.7e308)
(defconstant least-positive-single-float 1.7e-308)
(defconstant most-negative-single-float -1.7e308)
(defconstant least-negative-single-float -1.7e-308)
(defconstant most-positive-double-float 1.7e308)
(defconstant least-positive-double-float 1.7e-308)
(defconstant most-negative-double-float -1.7e308)
(defconstant least-negative-double-float -1.7e-308)
(defconstant most-positive-long-float 1.7e308)
(defconstant least-positive-long-float 1.7e-308)
(defconstant most-negative-long-float -1.7e308)
(defconstant least-negative-long-float -1.7e-308)
(defconstant short-float-epsilon 1.7e-308)
(defconstant single-float-epsilon 1.7e-308)
(defconstant double-float-epsilon 1.7e-308)
(defconstant long-float-epsilon 1.7e-308)
(defconstant short-float-negative-epsilon -1.7e-308)
(defconstant single-float-negative-epsilon -1.7e-308)
(defconstant double-float-negative-epsilon -1.7e-308)
(defconstant long-float-negative-epsilon -1.7e-308)

;;; Chapter 13 -- CHARACTERS
(defconstant char-code-limit 128)
(defconstant char-font-limit 65536)
(defconstant char-bits-limit 4)
(defconstant char-control-bit 1)
(defconstant char-meta-bit 2)
(defconstant char-super-bit 0)
(defconstant char-hyper-bit 0)

;;; Chapter 17 -- ARRAYS

(defconstant array-rank-limit 65536)
(defconstant array-dimension-limit 4294967296)
(defconstant array-total-size-limit 8388608)

;;; Chapter 23 -- FILE SYSTEM INTERFACE
; N/A under DOS
(defun file-author(fn) nil)

;;; Chapter 25 -- MISCELLANEOUS FEATURES

;; OTHER ENVIRONMENT INQUIRIES (25.4.2)
;; change these to fit your system.
(defun lisp-implementation-type() '"Star Sapphire Common LISP")
(defun lisp-implementation-version() '"3.4")
(defun machine-type() '"IBM PC and compatibles")
(defun machine-version() '"80486")
(defun machine-instance() '"madonna")
(defun software-type() '"MS-DOS")
(defun software-version() '"5.0")
(defun short-site-name() '"Sapiens")
(defun long-site-name() '"Sapiens Software")
;; identity
(defun identity (x) x)
