; :ts=2
; The queens problem: from "Introduction to Common LISP"
; by Taiichi Yuasa and Masami Hagiya (Academic Press, 1987):
; Print all possible ways that n queens can be placed on a chess
; board of n squares.  To run this, type
;
;   (queen 4)
;
; for instance.
; The current problem is that printing the solutions is difficult
; to interrupt: you may need to reboot your system to break out of
; a long solution set.

(defun queen(n)
	(queen1 n 0 0 nil nil nil))
(defun queen1(n i j column left right)
	(cond
		((equal i n)
			(terpri)
			(print-solution n column)
			nil)
		((equal j n) nil)
		((or (member j column)
			(member (+ i j) left)
			(member (- i j) right))
			(queen1 n i (1+ j)
				column left right))
		((queen1 n (1+ i) 0
								(cons j column)
								(cons (+ i j) left)
								(cons (- i j) right)))
		((queen1 n i (1+ j)
					column left right))))
(defun print-solution (n x)
	(do ((y x (cdr y)))
				((null y))
			(terpri)
			(do ((i 0 (1+ i)))
					((equal i (car y)))
				(princ ". "))
			(princ "Q ")
			(do ((i 0 (1+ i)))
					((equal i (- n (car y) 1)))
				(princ ". "))))
