; 'exact' number of IBM PC clock ticks per second.
(defconstant internal-time-units-per-second 18.206491)

; the time macro (highly IBM PC/Star Sapphire specific)
(defmacro time(form)
	`(progn
	  (format t "Start: ~a~%" (time-of-day))
	  (let ((start (get-internal-real-time))	; save clock on entry
		   (retval ,form))						; run form and save result
		; compute number of seconds in evaluation and print it
		; takes into account the midnight bit (second, nonstd return
		; from get-internal-real-time)
		(let ((end (multiple-value-list (get-internal-real-time))))
			; (format t "start at ~s, end at ~s~%" start (first end))
			(format t "End: ~a~%" (time-of-day))
			(format t "~%~g seconds~%" 
				(/	; convert into seconds
					; if midnight bit set or start less than end
					(if (or (second end)(> start (first end)))
						; take into account a days' worth of clock ticks
						(+ (- (* 86400 internal-time-units-per-second) start)
						   (first end))	; to correct for time warp at midnight
						(- (first end) start))	; else more normal calculation
					internal-time-units-per-second)))
		; return result of form from outermost let
		 retval)))
